(function () {
    if (typeof window.checkout !== "undefined") {
        /**
         * Override the method when placing order
         */
        var save = window.FireCheckout.prototype.save;
        window.FireCheckout.prototype.save = function (urlSuffix, forceSave) {
            // if we have scalapay method
            if (payment.currentMethod == 'scalapay') {
                this.urls.save = window.Scalapay.saveUrl;

                /**
                 *redirect if we get ulr in responce
                 */
                this.setResponse = function (transport) {
                    var response = {};
                    // Parse the response
                    try {
                        response = JSON.parse(transport.responseText);
                    } catch (e) {
                        response = {};
                    }
                    // If response success
                    if (response.success) {
                        window.location.href = response.redirect;
                    } else {
                        if (response.redirect) {
                            this.isSuccess = false;
                            window.location.href = response.redirect;
                        } else {
                            alert(response.message);
                        }
                    }
                };
            }
            // call the original function
            save.apply(this, arguments);
        }
    }
    // update scalapay breakdown price on shiping method selection

    $$('input[type="radio"][name="shipping_method"]').each(function (el) {
        Event.observe(el, 'click', function () {
            if (el.checked == true) {
                var getShippingCode = el.getValue();
                setTimeout(function () {
                    jQuery.ajax({
                        url: Scalapay.CheckoutForm.baseURL + 'scalapay/index/updatedTotal',
                        dataType: 'json',
                        type: 'post',
                        success: function (data) {
                            jQuery('#scalapay_price').html(data.total);
                        }
                    });
                }, 500);
            }
        });
    });
})();

/** update Scalapay price on country selection******/
document.observe('dom:loaded', function () {
    $('billing:country_id').observe('change', function (e) {
        jQuery.ajax({
            url: window.Scalapay.baseURL + 'scalapay/index/selectCountry',
            dataType: 'json',
            type: 'get',
            data: 'country_id=' + this.value,
            success: function (data) {
                if (jQuery('#p_method_scalapay').length > 0) {
                    if (data.show) {
                        jQuery('#p_method_scalapay').parent().show();
                    } else {
                        jQuery('#p_method_scalapay').parent().hide();
                    }
                } else {
                    if (data.show) {
                        jQuery('.firecheckout-loader').addClass("shown");
                        window.location.reload();
                    }
                }
            }
        });
    });

    var target_value = document.getElementById('billing:country_id').value;
    if (target_value != "") {
        jQuery.ajax({
            url: window.Scalapay.baseURL + 'scalapay/index/selectCountry',
            dataType: 'json',
            type: 'get',
            data: 'country_id=' + target_value,
            success: function (data) {
                if (jQuery('#p_method_scalapay').length > 0) {
                    if (data.show) {
                        jQuery('#p_method_scalapay').parent().show();
                    } else {
                        jQuery('#p_method_scalapay').parent().hide();
                    }
                } else {
                    if (data.show) {
                        jQuery('.firecheckout-loader').addClass("shown");
                        window.location.reload();
                    }
                }
            }
        });
    }
});