/**
 * Function specifically for Idev OneStepCheckout. The class especially for it
 */
(function () {
    var form = $('onestepcheckout-form');
    var action = form.getAttribute('action');

    // save in variable for default .submit
    var original = form.submit;


    form.submit = function () {
    //jQuery("#onestepcheckout-place-order").on("click", function() {
        if (payment.currentMethod == 'scalapay') {
            // prepare params
            var params = form.serialize(true);

            var customer_password = jQuery('#billing\\:customer_password').val();

            if ( typeof customer_password !== 'undefined' && customer_password.length ) {
                params.create_account = 1;
            }

            // Registration handling
            doScalapayAPICall(window.Scalapay.saveUrl, params);
            return false;
        } else {
            original.apply(this, arguments);
        }
    //}); For the jQuery version
    };
})();


function doScalapayAPICall( saveURL, params )
{
    // Ajax to start order token
    var request = new Ajax.Request(
        saveURL,
        {
            method: 'post',
            parameters: params,
            onSuccess: function (transport) {
                var response = {};

                // Parse the response - lifted from original method
                try {
                    response = eval('(' + transport.responseText + ')');
                } catch (e) {
                    response = {};
                }

                // if the order has been successfully placed
                if (response.success) {
                    var response = {};

                    // Parse the response
                    try {
                        response = JSON.parse(transport.responseText);
                    } catch (e) {
                        response = {};
                    }

                    // If response success
                    if (response.success) {
                        window.location.href = response.redirect;
                    } else {
                        if (response.redirect) {
                            this.isSuccess = false;
                            window.location.href = response.redirect;
                        } else {
                            alert(response.message);
                        }
                    }
                }

            }.bind(this),
            onFailure: function () {
                alert('Scalapay Gateway is not available.');
            }
        }
    );
}